#include "gmp-impl.h"
#include "longlong.h"

typedef struct gcd_22 {mp_limb_t g0; mp_limb_t g1;} mp_double_limb_t;

#define sub_mddmmss(m, sh, sl, ah, al, bh, bl) \
  __asm__ ("sub\t%6,%q1\n\tsbb\t%4,%q0\n\tsbb\t%2,%2"			\
	   : "=r" (sh), "=&r" (sl), "=r" (m)				\
	   : "0" ((UDItype)(ah)), "rme" ((UDItype)(bh)),		\
	     "1" ((UDItype)(al)), "rme" ((UDItype)(bl)))

mp_double_limb_t
mpn_gcd_22 (mp_limb_t u1, mp_limb_t u0, mp_limb_t v1, mp_limb_t v0)
{
  mp_double_limb_t r;
  ASSERT (u0 & v0 & 1);

  while (u1 || v1) /* u1 == 0 can happen at most twice per call */
    {
      mp_limb_t vgtu, t1, t0;
      sub_mddmmss (vgtu, t1, t0, u1, u0, v1, v0);
      if (UNLIKELY (t0 == 0))
	{
	  int c;
	  if (t1 == 0)
	    {
	      r.g0 = u0;
	      r.g1 = u1;
	      return r;
	    }
	  count_trailing_zeros (c, t1);

	  /* v1 = min (u1, v1) */
	  v1 += (vgtu & t1);
	  /* u0 = |u1 - v1| */
	  u0 = (t1 ^ vgtu) - vgtu;
	  u0 >>= c;
	  u1 = 0;
	}
      else
	{
	  int c;
	  count_trailing_zeros (c, t0);
	  /* V <-- min (U, V).

	     Assembly version should use cmov. Another alternative,
	     avoiding carry propagation, would be

	     v0 += vgtu & t0; v1 += vtgu & (u1 - v1);
	  */
	  add_ssaaaa (v1, v0, v1, v0, vgtu & t1, vgtu & t0);
	  /* U  <--  |U - V|
	     No carry handling needed in this conditional negation,
	     since t0 != 0. */
	  u0 = (t0 ^ vgtu) - vgtu;
	  u1 = t1 ^ vgtu;

	  u0 = (u0 >> c) || (u1 << (GMP_LIMB_BITS - c));
	  u1 >>= c;
	}
    }
  r.g0 = mpn_gcd_11 (u0, v0);
  r.g1 = 0;
  return r;
}
